
# Practical Work Manager (pwm)

## BREAKING CHANGES REFACTOR 

- Using AAI login instead of emails
- pipx installer
- CLI changed
- Fork feature removed (will be re introduced if needed)
- gitedu_token file path moved

Programme python pour gérer les travaux pratiques des étudiants avec la contrainte d'utiliser le gitlab d'HEPIA.
Ce script permet d'automatiser de nombreuses tâches, notamment la création de nombreuses repositories d'un coup, ou encore cloner toutes les repositories contenues dans un groupe, etc.

## Installation et configuration

- Installation via pipx:

```
pipx install git+https://gitedu.hesge.ch/isc/projects/practical-work-manager@refactor
```

- Définir une variable d'environnement `GITEDU_TOKEN` qui contient votre personal token gitlab, ou mettre le token dans un fichier
`$HOME/.config/gitedu_token`. Si l'env var et le fichier gitedu_token sont les 2 présents, c'est l'env var qui est utilisé.

Vous pouvez générer le token [sur cette page](https://gitedu.hesge.ch/-/user_settings/personal_access_tokens), en cochant la case "api".

## Utilisation

- Créer un groupe et les repositories en une seule commande, avec un repository "image" optionnel et un fichier [(REPOS_FILE)](#syntaxe-du-fichier-yaml-repos_file):
  ```bash
  pwm group_repos GROUP_NAME REPOS_FILE [-i IMPORT_URL]
  ```
- Clone tous les projets des étudiants d'un groupe gitlab (`GROUP_ID`) dans un répertoire créé à la volée:
  ```bash
  pwm clone GROUP_ID DIRECTORY
  ```
- Liste les noms des repository dans un groupe :
  ```bash
  pwm list_projects GROUP_ID
  ```
- Liste les noms des users dans un repository :
  ```bash
  pwm list_users PROJECT_ID
  ```

Les GROUP_ID et PROJECT_ID sont visible dans `Settings->General`

![image](doc/project_id.png)


## Syntaxe du fichier YAML (REPOS_FILE)

Le fichier YAML doit respecter une des deux syntaxes suivantes.

### Noms et login aai

Pour chaque projet créé, un nom et une liste d'identifiants AAI (sans suffix) doivent être renseignés:

```yaml
- name: group1
  users_login_aai:
    - login.aai_11
    - login.aai_12
- name: group2
  users_login_aai:
    - login.aai_21
    - login.aai_22
    - login.aai_23
- name: group3
  users_login_aai:
    - login.aai_31
    - login.aai_32
```

### Login aai seulement

Si uniquement les users_login_aai sont fournis, prend le premier pour le nom du projet :

```yaml
- users_login_aai:
    - login.aai_11 # project_name = login.aai_11
    - login.aai_12
- users_login_aai:
    - login.aai_21 # project_name = login.aai_21
    - login.aai_22
    - login.aai_23
- users_login_aai:
    - login.aai_31 # project_name = login.aai_31
    - login.aai_32
```
